#include "Extern_Declaration.h"

void CopyBack(unsigned int SrcPage, unsigned int SrcBlock,unsigned int DestPage, unsigned int DestBlock)
{
	
	// check if write buffer is empty or not:
	
	while(!(*pNFC_STAT & WB_EMPTY));
	
	*pNFC_CMD =  CopyBackCmd[0];
	
	/*  
	
	Set up the source address cycles depending on Page and Block number passed:
	
	Column: A0-A11
	Page: 	A12-A17
	Block: 	A18-A28
	
	
	1st Address Cycle: A0-A7
	2nd Address Cycle: A8-A11
	3rd Address Cycle: A12-A19
	4th Address Cycle: A20-A27
	5th Address Cycle: A28
	
	*/
	
	short temp_Page = SrcPage;
	short temp_Block = SrcBlock;
	
	//Column
	*pNFC_ADDR = 0;
	*pNFC_ADDR = 0;
	
	//Page
	
	temp_Page = SrcBlock & 3;		// Get bits A18 and A19 from Block address
	temp_Page = temp_Page << 6;		// Shift to append with Page Address
	
	SrcPage = SrcPage | temp_Page;
	
	// First 2 bits of Block and 6 bits of Page are sent
	*pNFC_ADDR = SrcPage;	
	
	// check if write buffer is empty or not:
	
	while(!(*pNFC_STAT & WB_EMPTY));	
	
	// Next 8 bits of Block address. i.e till 1023. 
			
	SrcBlock = temp_Block;
	SrcBlock = SrcBlock & 0x3FC;	// Mask to get A20-A27	
	SrcBlock = SrcBlock >> 2;		// Because A18 and A19 are already sent out
	
	*pNFC_ADDR = SrcBlock;
	
		
	// Block address greater than 1023
	
	SrcBlock = temp_Block;
	SrcBlock = SrcBlock & 0xFC00;	// Mask to get A28-A30
	SrcBlock = SrcBlock >> 10;		// Because A18-A27 are already sent out
	
	*pNFC_ADDR = SrcBlock;
	
	// Wait till write buffer is empty:
	
	while(!(*pNFC_STAT & WB_EMPTY));
	
	
	*pNFC_CMD =  CopyBackCmd[1];	 
	
		
	//Wait till NBUSY Flag sets.
	
	while(!(NBUSY_Flag));
	NBUSY_Flag = 0;
	
	
	*pNFC_CMD =  CopyBackCmd[2];
		
	
	/*  
	
	Set up the Dest address cycles depending on Page and Block number passed:
	
	Column: A0-A11
	Page: 	A12-A17
	Block: 	A18-A28
	
	
	1st Address Cycle: A0-A7
	2nd Address Cycle: A8-A11
	3rd Address Cycle: A12-A19
	4th Address Cycle: A20-A27
	5th Address Cycle: A28
	
	*/
	
	temp_Page = DestPage;
	temp_Block = DestBlock;
	
	//Column
	*pNFC_ADDR = 0;
	*pNFC_ADDR = 0;
	
	//Page
	
	temp_Page = DestBlock & 3;		// Get bits A18 and A19 from Block address
	temp_Page = temp_Page << 6;	// Shift to append with Page Address
	
	DestPage = DestPage | temp_Page;
	
	// First 2 bits of Block and 6 bits of Page are sent
	*pNFC_ADDR = DestPage;	
	
	// check if write buffer is empty or not:
	
	while(!(*pNFC_STAT & WB_EMPTY));	
	
	// Next 8 bits of Block address. i.e till 1023. 
			
	DestBlock = temp_Block;
	DestBlock = DestBlock & 0x3FC;	// Mask to get A20-A27	
	DestBlock = DestBlock >> 2;		// Because A18 and A19 are already sent out
	
	*pNFC_ADDR = DestBlock;
	
		
	// Block address greater than 1023
	
	DestBlock = temp_Block;
	DestBlock = DestBlock & 0xFC00;	// Mask to get A28-A30
	DestBlock = DestBlock >> 10;		// Because A18-A27 are already sent out
	
	*pNFC_ADDR = DestBlock;
	
	
	// Wait till write buffer is empty:
	
	while(!(*pNFC_STAT & WB_EMPTY));
	
	
	*pNFC_CMD =  CopyBackCmd[3];	 
	
			
	//Wait till NBUSY Flag sets.
	
	while(!(NBUSY_Flag));
	NBUSY_Flag = 0;
	
	Read_Flash_Status_Register();
	
	printf("CopyBack is Completed \n");
		
}


	
	
